



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MongoDB - The mongo Shell, Data Types in the mongo Shell</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MongoDB - The mongo Shell, Data Types in the mongo Shell</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 13:55:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>MongoDB&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/glossary/#term-bson" rel="external nofollow noreferrer">BSON</a>&nbsp;provides support for additional data types than&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/glossary/#term-json" rel="external nofollow noreferrer">JSON</a>.&nbsp;<a href="https://docs.mongodb.com/v3.2/applications/drivers/" rel="external nofollow noreferrer">Drivers</a>&nbsp;provide native support for these data types in host languages and the&nbsp;<tt>mongo</tt>&nbsp;shell also provides several helper classes to support the use of these data types in the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;JavaScript shell. See the&nbsp;<a href="http://www.cnblogs.com/huey/p/6118848.html" rel="external nofollow noreferrer">Extended JSON</a>&nbsp;reference for additional information.</p>
<h2>Types</h2>
<h3>Date</h3>
<p>The&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell provides various methods to return the date, either as a string or as a&nbsp;<tt>Date</tt>&nbsp;object:</p>
<ul><li><tt>Date()</tt>&nbsp;method which returns the current date as a string.</li>
<li>new Date()&nbsp;constructor which returns a&nbsp;<tt>Date</tt>&nbsp;object using the&nbsp;<tt>ISODate()</tt>&nbsp;wrapper.</li>
<li><tt>ISODate()</tt>&nbsp;constructor which returns a&nbsp;<tt>Date</tt>&nbsp;object using the&nbsp;<tt>ISODate()</tt>&nbsp;wrapper.</li></ul>
<p>Internally,&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/bson-types/#document-bson-type-date" rel="external nofollow noreferrer">Date</a>&nbsp;objects are stored as a 64 bit integer representing the number of milliseconds since the Unix epoch (Jan 1, 1970), which results in a representable date range of about 290 millions years into the past and future.</p>
<h4>Return Date as a String</h4>
<p>To return the date as a string, use the&nbsp;<tt>Date()</tt>&nbsp;method, as in the following example:</p>
<div>
<pre class="prettyprint linenums">var myDateString = Date();</pre>
</div>
<p>To print the value of the variable, type the variable name in the shell, as in the following:</p>
<div>
<pre class="prettyprint linenums">myDateString</pre>
</div>
<p>The result is the value of&nbsp;<tt>myDateString</tt>:</p>
<div>
<pre class="prettyprint linenums">Thu Dec 01 2016 00:44:26 GMT+0800 (CST)</pre>
</div>
<p>To verify the type, use the&nbsp;<tt>typeof</tt>&nbsp;operator, as in the following:</p>
<div>
<pre class="prettyprint linenums">typeof myDateString</pre>
</div>
<p>The operation returns&nbsp;<tt>string</tt>.</p>
<h4>Return&nbsp;<tt>Date</tt></h4>
<p>The&nbsp;<tt>mongo</tt>&nbsp;shell wraps objects of&nbsp;<tt>Date</tt>&nbsp;type with the&nbsp;<tt>ISODate</tt>&nbsp;helper; however, the objects remain of type&nbsp;<tt>Date</tt>.</p>
<p>The following example uses both the&nbsp;<tt>new&nbsp;Date()</tt>&nbsp;constructor and the&nbsp;<tt>ISODate()</tt>&nbsp;constructor to return&nbsp;<tt>Date</tt>&nbsp;objects.</p>
<div>
<pre class="prettyprint linenums">var myDate = new Date();<br />
var myDateInitUsingISODateWrapper = ISODate();</pre>
</div>
<p>You can use the&nbsp;<tt>new</tt>&nbsp;operator with the&nbsp;<tt>ISODate()</tt>&nbsp;constructor as well.</p>
<p>To print the value of the variable, type the variable name in the shell, as in the following:</p>
<div>
<pre class="prettyprint linenums">myDate</pre>
</div>
<p>The result is the&nbsp;<tt>Date</tt>&nbsp;value of&nbsp;<tt>myDate</tt>&nbsp;wrapped in the&nbsp;<tt>ISODate()</tt>&nbsp;helper:</p>
<div>
<pre class="prettyprint linenums">ISODate("2016-11-30T16:48:47.527Z")</pre>
</div>
<p>To verify the type, use the&nbsp;<tt>instanceof</tt>&nbsp;operator, as in the following:</p>
<div>
<pre class="prettyprint linenums">myDate instanceof Date<br />
myDateInitUsingISODateWrapper instanceof Date</pre>
</div>
<p>The operation returns&nbsp;<tt>true</tt>&nbsp;for both.</p>
<h3>ObjectId</h3>
<p>The&nbsp;<tt>mongo</tt>&nbsp;shell provides the&nbsp;<tt>ObjectId()</tt>&nbsp;wrapper class around the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/bson-types/#objectid" rel="external nofollow noreferrer">ObjectId</a>&nbsp;data type. To generate a new ObjectId, use the following operation in the&nbsp;<tt>mongo</tt>&nbsp;shell:</p>
<div>
<pre class="prettyprint linenums">new ObjectId</pre>
</div>
<p><strong>SEE:</strong>&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/method/ObjectId/#ObjectId" rel="external nofollow noreferrer"><tt>ObjectId</tt></a></p>
<h3>NumberLong</h3>
<p>By default, the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell treats all numbers as floating-point values. The&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell provides the<tt>NumberLong()</tt>&nbsp;wrapper to handle 64-bit integers.</p>
<p>The&nbsp;<tt>NumberLong()</tt>&nbsp;wrapper accepts the long as a string:</p>
<div>
<pre class="prettyprint linenums">NumberLong("2090845886852")</pre>
</div>
<p>The following examples use the&nbsp;<tt>NumberLong()</tt>&nbsp;wrapper to write to the collection:</p>
<div>
<pre class="prettyprint linenums">db.collection.insert( { _id: 10, calc: NumberLong("2090845886852") } )<br />
db.collection.update( { _id: 10 }, { $set:  { calc: NumberLong("2555555000000") } } )<br />
db.collection.update( { _id: 10 }, { $inc: { calc: NumberLong(5) } } )</pre>
</div>
<p>Retrieve the document to verify:</p>
<div>
<pre class="prettyprint linenums">db.collection.findOne( { _id: 10 } )</pre>
</div>
<p>In the returned document, the&nbsp;<tt>calc</tt>&nbsp;field contains a&nbsp;<tt>NumberLong</tt>&nbsp;object:</p>
<div>
<pre class="prettyprint linenums">{ "_id" : 10, "calc" : NumberLong("2555555000005") }</pre>
</div>
<p>If you use the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/operator/update/inc/#up._S_inc" rel="external nofollow noreferrer"><tt>$inc</tt></a>&nbsp;to increment the value of a field that contains a&nbsp;<tt>NumberLong</tt>&nbsp;object by a&nbsp;float, the data type changes to a floating point value, as in the following example:</p>
<ol><li>Use&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/operator/update/inc/#up._S_inc" rel="external nofollow noreferrer"><tt>$inc</tt></a>&nbsp;to increment the&nbsp;<tt>calc</tt>&nbsp;field by&nbsp;<tt>5</tt>, which the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell treats as a float:</p>
<div>
<pre class="prettyprint linenums">db.collection.update( { _id: 10 }, { $inc: { calc: 5 } } )</pre>
</div></li>
<li>Retrieve the updated document:
<div>
<pre class="prettyprint linenums">db.collection.findOne( { _id: 10 } )</pre>
</div>
<p>In the updated document, the&nbsp;<tt>calc</tt>&nbsp;field contains a floating point value:</p>
<div>
<pre class="prettyprint linenums">{ "_id" : 10, "calc" : 2555555000010 }</pre>
</div></li></ol>
<h3>NumberInt</h3>
<p>By default, the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell treats all numbers as floating-point values. The&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell provides the<tt>NumberInt()</tt>&nbsp;constructor to explicitly specify 32-bit integers.</p>
<h2>Check Types in the&nbsp;<tt>mongo</tt>&nbsp;Shell</h2>
<p>To determine the type of fields, the&nbsp;<a href="https://docs.mongodb.com/v3.2/reference/program/mongo/#bin.mongo" rel="external nofollow noreferrer"><tt>mongo</tt></a>&nbsp;shell provides the&nbsp;<tt>instanceof</tt>&nbsp;and&nbsp;<tt>typeof</tt>&nbsp;operators.</p>
<h3><tt>instanceof</tt></h3>
<p><tt>instanceof</tt>&nbsp;returns a boolean to test if a value is an instance of some type.</p>
<p>For example, the following operation tests whether the&nbsp;<tt>_id</tt>&nbsp;field is an instance of type&nbsp;<tt>ObjectId</tt>:</p>
<div>
<pre class="prettyprint linenums">mydoc._id instanceof ObjectId</pre>
</div>
<p>The operation returns&nbsp;<tt>true</tt>.</p>
<h3><tt>typeof</tt></h3>
<p><tt>typeof</tt>&nbsp;returns the type of a field.</p>
<p>For example, the following operation returns the type of the&nbsp;<tt>_id</tt>&nbsp;field:</p>
<div>
<pre class="prettyprint linenums">typeof mydoc._id</pre>
</div>
<p>In this case&nbsp;<tt>typeof</tt>&nbsp;will return the more generic&nbsp;<tt>object</tt>&nbsp;type rather than&nbsp;<tt>ObjectId</tt>&nbsp;type.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z1y019.html">Java中的关键字 transient</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kjey59.html">一个网站完整详细的SEO优化方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwroe39.html">onTouch与onClick冲突解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4vr79.html">做哪些优化，才能让 UITabelView 更顺滑？&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oezk59.html">在 Ubuntu 配置 PPTP Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0z0rlq.html">UTF-8 有BOM和无BOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdezp779.html">advance 模板 怎么生成module</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okzzdp9.html">1&period;C语言关键字（auto break case char const swtich）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1dmpe9.html">timeout Timeout时间已到&period;在操作完成之前超时时间已过或服务器未响应</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljp67e9.html">TFboy养成记 多层感知器 MLP</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojrd0lq.html">【&period;NET Core】docker Jenkins ASP&period;NET Core自动化部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1o138.html">android 标准OTA升级流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9502e768.html">微信小程序中的AJAX&mdash;&mdash;POST，GET区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodwxdq.html">Python爬虫实战之Requests&plus;正则表达式爬取猫眼电影Top100</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwkx48.html">ElasticSearch - 信息聚合系列之聚合过滤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rz1028.html">python之路&mdash;&mdash;24</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1yvpxq.html">python学习之旅（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdyxej9.html">cocos2d-x 贡献一个oss上传脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvzxk28.html">Python中的对象行为与特殊方法&lpar;二&rpar;类型检查与抽象基类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko1v16q.html">linux解压</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gm42m09.html">通过RDB还原用户误删除的邮件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnl3lpq.html">c&plus;&plus;训练营--重载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1275g8.html">在linux下修改oracle的sys和system的密码和用户解锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wmopxq.html">拖动窗体FormBorderStyle属性为None的窗体移动</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0nkj0q.html">Entity Framework 6 Code First &plus;MVC5&plus;MySql&sol;Oracle使用过程中的几个问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxno1vj8.html">Codeforces Round &num;188 &lpar;Div&period; 2&rpar; C&period; Perfect Pair 数学</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0nyggq.html">网站性能扩展案例：每天30-50亿请求，300K QPS是如何炼成的</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn12ro38.html">opencv官网</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnewjz8.html">&lbrack;AngularJS&rsqb; Accessing Scope from The Console</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnpm10q.html">读取svg图片为UIBezierPath，开心做动画</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
